import { Observable, Observer, PartialObserver, Subscribable, Subscriber, Unsubscribable } from "rxjs"
import { FisAppActor } from "./transport.interface"


export type TYPE = {
    adapterProfile: AdapterProfile,
    transmitterProfile: TransmitterProfile,
    receiverProfile: ReceiverProfile
}

export interface AdapterProfile {

}

export interface TransmitterProfile {
    id: string,
    name: string,
    dateCreated: Date
}

export interface ReceiverProfile {
    id: string,
    name: string,
    dateCreated: Date
}

export interface ConnectionManager {

}

export interface ConnectionAdaptorBase<T> extends FisAppActor, Subscribable<T> {
    connector: any
    connectorProfile: AdapterProfile | any
    connectionState: ConnectionState
    connectionStateBus: Observable<ConnectionState>
    adaptorTransmissionRole: AdaptorTransmissionRole

    subscribeConnectionState(): Observable<ConnectionState>
    publishConnectionState(): void
    connect(): void
    disconnect(): void
    send(message: any): Observable<any>
    emit(message: any): void
    emitStream(message: any): void
    subscribeMessages(messageFilter: any): Observable<any>
}


export interface TransmitterConnectionAdapterBase<T> extends ConnectionAdaptorBase<T> {

}

export interface ReceiverConnectionAdapterBase<T> extends ConnectionAdaptorBase<T> {

}

export type ConnectionState = 'ONLINE' | 'OFFLINE'
export enum AdaptorTransmissionRole {
    Transmitter,
    Receiver,
    RequestResponse
}