import { Observable, Subject, Subscribable } from "rxjs";
import { AdaptorTransmissionRole, ReceiverProfile, TransmitterProfile } from "./connector.interface";

export interface FisAppActor {
    incomingMessageBus: Subject<any>
    outgoingMessageBus: Subject<any>

    send(message: any): Observable<any>
    emit(message: any): void
    emitStream(message: any): void
    subscribeMessages(messageFilter: any): Observable<any>
}

export interface MessageTransmissionManager {
    // what the hell is this here for
}


export interface MessageTransmissionBase<T> extends FisAppActor, Subscribable<T> {
    transmitterProfile: TransmitterProfile
    receiverProfile: ReceiverProfile
    msgRepositoryService: any
    transmissionRole: AdaptorTransmissionRole
    adaptorsArray: any[]
    transmissionService: any
    adapterService: any

    setTransmitter(transmitterProfile: TransmitterProfile): void
    setReceiver(receiverProfile: ReceiverProfile): void
}

export interface MessageReceiver<T> extends MessageTransmissionBase<T> {

}

export interface MessageTransmitter<T> extends MessageTransmissionBase<T> {

}

export interface MessageRequestResponse<T> extends MessageTransmissionBase<T>, MessageReceiver<T> {

}

export interface FisMessage {
    header: {
        messageID: string,
        messageName: `NotificationMessage` | `ResponseMessage` | `RequestMessage`
    },
    data: any
}

export interface TransmisionMessage {
    transmitter?: TransmitterProfile,
    receiver?: ReceiverProfile,
    payload?: FisMessage
}